CREATE OR REPLACE FUNCTION bit_over_left(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_over_left(varbit, varbit) IS 'is over and left of (NOT IMPLEMENTED)';

CREATE OR REPLACE FUNCTION bit_over_right(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_over_right(varbit, varbit) IS 'is over and right of (NOT IMPLEMENTED)';

CREATE OR REPLACE FUNCTION bit_left(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_left(varbit, varbit) IS
'is left of (NOT IMPLEMENTED)';

CREATE OR REPLACE FUNCTION bit_right(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_right(varbit, varbit) IS 'is right of (NOT IMPLEMENTED)';


-- Comparison methods

CREATE OR REPLACE FUNCTION bit_eq(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_eq(varbit, varbit) IS 'same as';

CREATE OR REPLACE FUNCTION bit_contains(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_contains(varbit, varbit) IS 'contains';

CREATE OR REPLACE FUNCTION bit_contained(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_contained(varbit, varbit) IS 'contained in';

CREATE OR REPLACE FUNCTION bit_overlap(varbit, varbit)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

COMMENT ON FUNCTION bit_overlap(varbit, varbit) IS 'overlaps';

-- support routines for indexing

CREATE OR REPLACE FUNCTION bit_union(varbit, varbit)
RETURNS varbit
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION bit_inter(varbit, varbit)
RETURNS varbit
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION bit_size(varbit)
RETURNS float8
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;


-- Misc N-dimensional functions

-- proximity routines

CREATE OR REPLACE FUNCTION bit_distance(varbit, varbit)
RETURNS float8
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' IMMUTABLE STRICT;


--
-- OPERATORS
--

CREATE OPERATOR #<< (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_left,
	COMMUTATOR = '#>>',
	RESTRICT = positionsel, JOIN = positionjoinsel
);

CREATE OPERATOR #&< (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_over_left,
	COMMUTATOR = '#&>',
	RESTRICT = positionsel, JOIN = positionjoinsel
);

CREATE OPERATOR #&& (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_overlap,
	COMMUTATOR = '#&&',
	RESTRICT = positionsel, JOIN = positionjoinsel
);

CREATE OPERATOR #&> (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_over_right,
	COMMUTATOR = '#&<',
	RESTRICT = positionsel, JOIN = positionjoinsel
);

CREATE OPERATOR #>> (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_right,
	COMMUTATOR = '#<<',
	RESTRICT = positionsel, JOIN = positionjoinsel
);

CREATE OPERATOR #= (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_eq,
	COMMUTATOR = '#=',
	RESTRICT = eqsel, JOIN = eqjoinsel,
	MERGES
);

CREATE OPERATOR #@ (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_contains,
	COMMUTATOR = '#~',
	RESTRICT = contsel, JOIN = contjoinsel
);

CREATE OPERATOR #~ (
	LEFTARG = varbit, RIGHTARG = varbit, PROCEDURE = bit_contained,
	COMMUTATOR = '#@',
	RESTRICT = contsel, JOIN = contjoinsel
);


-- define the GiST support methods
CREATE OR REPLACE FUNCTION g_bit_consistent(internal,varbit,int4)
RETURNS bool
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION g_bit_compress(internal)
RETURNS internal 
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION g_bit_decompress(internal)
RETURNS internal 
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION g_bit_penalty(internal,internal,internal)
RETURNS internal
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C' STRICT;

CREATE OR REPLACE FUNCTION g_bit_picksplit(internal, internal)
RETURNS internal
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION g_bit_union(internal, internal)
RETURNS varbit 
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION g_bit_same(varbit, varbit, internal)
RETURNS internal 
AS '/home/stark/src/bit_gist/bit_gist.so'
LANGUAGE 'C';


-- Create the operator classes for indexing

CREATE OPERATOR CLASS gist_bit_ops
    DEFAULT FOR TYPE varbit USING gist AS
	OPERATOR	1	#<< ,
	OPERATOR	2	#&< ,
	OPERATOR	3	#&& ,
	OPERATOR	4	#&> ,
	OPERATOR	5	#>> ,
	OPERATOR	6	#= ,
	OPERATOR	7	#@ ,
	OPERATOR	8	#~ ,
	FUNCTION	1	g_bit_consistent (internal, varbit, int4),
	FUNCTION	2	g_bit_union (internal, internal),
	FUNCTION	3	g_bit_compress (internal),
	FUNCTION	4	g_bit_decompress (internal),
	FUNCTION	5	g_bit_penalty (internal, internal, internal),
	FUNCTION	6	g_bit_picksplit (internal, internal),
	FUNCTION	7	g_bit_same (varbit, varbit, internal);
